////////////////////////////////////////////////////////////////

void Draw::input()
{
    if (!accelerate && (SDL_GetModState() & KMOD_SHIFT))
    {
        accelerate = true;
        acceleration = shift;
    }
    else if (accelerate && !(SDL_GetModState() & KMOD_SHIFT))
    {
        accelerate = false;
        acceleration = 1.0;
    }

    SDL_Event sdl_event;
    while (SDL_PollEvent(&sdl_event))
    {
        if (sdl_event.type == SDL_QUIT || (sdl_event.type == SDL_KEYDOWN && sdl_event.key.keysym.sym == SDLK_ESCAPE))
        {
            active = false;
        }
        else
        {
            switch (sdl_event.type)
            {
                case SDL_KEYDOWN:
                {
                    switch (sdl_event.key.keysym.sym)
                    {
                        case SDLK_w:
                        {
                            ypp++;
                            break;
                        }
                        case SDLK_s:
                        {
                            ypp--;
                            break;
                        }
                        case SDLK_a:
                        {
                            xpp--;
                            break;
                        }
                        case SDLK_d:
                        {
                            xpp++;
                            break;
                        }
                        case SDLK_q:
                        {
                            zpp--;
                            break;
                        }
                        case SDLK_e:
                        {
                            zpp++;
                            break;
                        }
                        case SDLK_b:
                        {
                            use_blending++;

                            if (use_blending > 2)
                            {
                                use_blending = 0;
                            }
                            break;
                        }
                        case SDLK_v:
                        {
                            show_vertexes = !show_vertexes;
                            break;
                        }
                        case SDLK_t:
                        {
                            show_triangles = !show_triangles;
                            break;
                        }
                        case SDLK_l:
                        {
                            show_lines = !show_lines;
                            break;
                        }
                        case SDLK_p:
                        {
                            if (!show_planes && !show_single_plane)
                            {
                                show_planes = true;
                            }
                            else if (!show_single_plane)
                            {
                                show_planes = false;
                                show_single_plane = true;
                            }
                            else if (!show_planes)
                            {
                                show_single_plane = false;
                            }
                            break;
                        }
                        case SDLK_g:
                        {
                            show_single_texture_group = !show_single_texture_group;
                            break;
                        }
                        case SDLK_r:
                        {
                            reset();
                            break;
                        }
                        case SDLK_i:
                        {
                            if (!show_information || (show_information && information_i == 1))
                            {
                                show_information = !show_information;
                            }

                            if (show_information)
                            {
                                information_i = 1;
                            }
                            break;
                        }
                        case SDLK_PAGEUP:
                        {
                            keys[24] = true;
                            break;
                        }
                        case SDLK_PAGEDOWN:
                        {
                            keys[25] = true;
                            break;
                        }
                        case SDLK_RIGHTBRACKET:
                        {
                            keys[125] = true;
                            break;
                        }
                        case SDLK_LEFTBRACKET:
                        {
                            keys[123] = true;
                            break;
                        }
                        case SDLK_QUOTE:
                        {
                            keys[39] = true;
                            break;
                        }
                        case SDLK_SEMICOLON:
                        {
                            keys[59] = true;
                            break;
                        }
                        case SDLK_PERIOD:
                        {
                            keys[46] = true;
                            break;
                        }
                        case SDLK_COMMA:
                        {
                            keys[44] = true;
                            break;
                        }
                        case SDLK_RIGHT:
                        {
                            if (show_single_texture_group)
                            {
                                if (texture_group_i == (bsp->texture_groups.size() - 1))
                                {
                                    texture_group_i = 0;
                                }
                                else
                                {
                                    texture_group_i++;
                                }
                            }
                            break;
                        }
                        case SDLK_LEFT:
                        {
                            if (show_single_texture_group)
                            {
                                if (texture_group_i == 0)
                                {
                                    texture_group_i = bsp->texture_groups.size() - 1;
                                }
                                else
                                {
                                    texture_group_i--;
                                }
                            }
                            break;
                        }
                        case SDLK_UP:
                        {
                            if (show_single_plane)
                            {
                                if (plane_i == (bsp->planes.size() - 1))
                                {
                                    plane_i = 0;
                                }
                                else
                                {
                                    plane_i++;
                                }
                            }
                            break;
                        }
                        case SDLK_DOWN:
                        {
                            if (show_single_plane)
                            {
                                if (plane_i == 0)
                                {
                                    plane_i = bsp->planes.size() - 1;
                                }
                                else
                                {
                                    plane_i--;
                                }
                            }
                            break;
                        }
                        case SDLK_F1:
                        {
                            if (!show_information || (show_information && information_i == 2))
                            {
                                show_information = !show_information;
                            }

                            if (show_information)
                            {
                                information_i = 2;
                            }
                            break;
                        }
                        case SDLK_F2:
                        {
                            if (!show_information || (show_information && information_i == 3))
                            {
                                show_information = !show_information;
                            }

                            if (show_information)
                            {
                                information_i = 3;
                            }
                            break;
                        }
                        case SDLK_F12:
                        {
                            screenshot();
                            break;
                        }
                    }
                    break;
                }
                case SDL_KEYUP:
                {
                    switch (sdl_event.key.keysym.sym)
                    {
                        case SDLK_w:
                        {
                            ypp--;
                            break;
                        }
                        case SDLK_s:
                        {
                            ypp++;
                            break;
                        }
                        case SDLK_a:
                        {
                            xpp++;
                            break;
                        }
                        case SDLK_d:
                        {
                            xpp--;
                            break;
                        }
                        case SDLK_q:
                        {
                            zpp++;
                            break;
                        }
                        case SDLK_e:
                        {
                            zpp--;
                            break;
                        }
                        case SDLK_PAGEUP:
                        {
                            keys[24] = false;
                            break;
                        }
                        case SDLK_PAGEDOWN:
                        {
                            keys[25] = false;
                            break;
                        }
                        case SDLK_RIGHTBRACKET:
                        {
                            keys[125] = false;
                            break;
                        }
                        case SDLK_LEFTBRACKET:
                        {
                            keys[123] = false;
                            break;
                        }
                        case SDLK_QUOTE:
                        {
                            keys[39] = false;
                            break;
                        }
                        case SDLK_SEMICOLON:
                        {
                            keys[59] = false;
                            break;
                        }
                        case SDLK_PERIOD:
                        {
                            keys[46] = false;
                            break;
                        }
                        case SDLK_COMMA:
                        {
                            keys[44] = false;
                            break;
                        }
                    }
                    break;
                }
                case SDL_MOUSEBUTTONDOWN:
                {
                    focussed = !focussed;

                    if (focussed)
                    {
                        SDL_ShowCursor(0);
                        SDL_WarpMouse(resolution.width / 2, resolution.height / 2);
                    }
                    else
                    {
                        SDL_ShowCursor(1);
                    }
                    break;
                }
            }
        }
    }

    if (focussed)
    {
        int dx = 0, dy = 0;
        SDL_GetMouseState(&dx, &dy);
        SDL_WarpMouse(resolution.width / 2, resolution.height / 2);

        x_angle += ((dx - (resolution.width / 2)) / 360.0) * rotation_speed;
        z_angle -= ((dy - (resolution.height / 2)) / 360.0) * rotation_speed;

        if (z_angle < -(0.5 - epsilon) * M_PI)
        {
            z_angle = -(0.5 - epsilon) * M_PI;
        }
        else if (z_angle > (0.5 - epsilon) * M_PI)
        {
            z_angle = (0.5 - epsilon) * M_PI;
        }
    }
}

////////////////////////////////////////////////////////////////

void Draw::process()
{
    if (xpp)
    {
        xp += cos(x_angle) * xpp * move_speed * multiplier() * acceleration;
        yp -= sin(x_angle) * xpp * move_speed * multiplier() * acceleration;
    }

    if (ypp)
    {
        xp += sin(x_angle) * ypp * move_speed * multiplier() * acceleration;
        yp += cos(x_angle) * ypp * move_speed * multiplier() * acceleration;
    }

    if (zpp)
    {
        zp += zpp * move_speed * multiplier() * acceleration;
    }

    xp *= friction;
    yp *= friction;
    zp *= friction;

    x += xp;
    y += yp;
    z += zp;

    if (keys[24]) // page up
    {
        clip_near *= 1.1 * acceleration;
        clip_far *= 1.1 * acceleration;

        to_3d();
    }

    if (keys[25]) // page down
    {
        clip_near /= 1.1 * acceleration;
        clip_far /= 1.1 * acceleration;

        to_3d();
    }

    if (keys[125]) // right bracket
    {
        point_size += 0.05 * acceleration;
        glPointSize(point_size);
    }

    if (keys[123]) // left bracket
    {
        if (point_size > 0.0)
        {
            point_size -= 0.05 * acceleration;
        }
        else
        {
            point_size = 0.0;
        }
        glPointSize(point_size);
    }

    if (keys[39]) // single quote
    {
        line_width += 0.05 * acceleration;
        glLineWidth(line_width);
    }

    if (keys[59]) // semicolon
    {
        if (line_width > 0.0)
        {
            line_width -= 0.05 * acceleration;
        }
        else
        {
            line_width = 0.0;
        }
        glLineWidth(line_width);
    }

    if (keys[46]) // period
    {
        alpha += 0.005 * acceleration;
    }

    if (keys[44]) // comma
    {
        if (alpha > 0.0)
        {
            alpha -= 0.005 * acceleration;
        }
        else
        {
            alpha = 0.0;
        }
    }
}

////////////////////////////////////////////////////////////////
