////////////////////////////////////////////////////////////////

void Draw::draw_planes()
{
    glBegin(GL_POINTS);
        std::vector<Plane>::iterator it;
        for (it = bsp->planes.begin(); it < bsp->planes.end(); it++)
        {
            if (show_single_plane)
            {
                it += plane_i;
            }

            glVertex3f(
                (*it).normal[0] * (*it).distance,
                (*it).normal[1] * (*it).distance,
                (*it).normal[2] * (*it).distance
            );

            if (show_single_plane)
            {
                break;
            }
        }
    glEnd();
}

////////////////////////////////////////////////////////////////

void Draw::draw_triangles()
{
    glBegin(GL_TRIANGLES);
        std::vector<TextureGroup>::iterator it;
        for (it = bsp->texture_groups.begin(); it < bsp->texture_groups.end(); it++)
        {
            if (show_single_texture_group)
            {
                it += texture_group_i;
            }

            if (!((*it).triangle_length % 3) && !((*it).triangle_offset % 3))
            {
                for (unsigned int n = 0; n < ((*it).triangle_length / 3); n++)
                {
                    unsigned int offset = ((*it).triangle_offset / 3);
                    for (unsigned int i = 0; i < 3; i++)
                    {
                        glColor4f(
                            colour[(*it).texture % N_COLOURS][0],
                            colour[(*it).texture % N_COLOURS][1],
                            colour[(*it).texture % N_COLOURS][2],
                            (bsp->vertexes[(*it).vertex_offset + bsp->triangles[offset + n].vertex[i]].alpha / 255.0f) * alpha
                        );

                        glVertex3f(
                            bsp->vertexes[(*it).vertex_offset + bsp->triangles[offset + n].vertex[i]].position[0],
                            bsp->vertexes[(*it).vertex_offset + bsp->triangles[offset + n].vertex[i]].position[1],
                            bsp->vertexes[(*it).vertex_offset + bsp->triangles[offset + n].vertex[i]].position[2]
                        );
                    }
                }
            }

            if (show_single_texture_group)
            {
                break;
            }
        }
    glEnd();
}

////////////////////////////////////////////////////////////////

void Draw::draw_lines()
{
    std::vector<TextureGroup>::iterator it;
    for (it = bsp->texture_groups.begin(); it < bsp->texture_groups.end(); it++)
    {
        if (show_single_texture_group)
        {
            it += texture_group_i;
        }

        if (!((*it).triangle_length % 3) && !((*it).triangle_offset % 3))
        {
            glColor4f(
                colour[((*it).texture + (N_COLOURS / 2)) % N_COLOURS][0],
                colour[((*it).texture + (N_COLOURS / 2)) % N_COLOURS][1],
                colour[((*it).texture + (N_COLOURS / 2)) % N_COLOURS][2],
                1.0f
            );

            for (unsigned int n = 0; n < ((*it).triangle_length / 3); n++)
            {
                glBegin(GL_LINE_LOOP);
                    unsigned int offset = ((*it).triangle_offset / 3);
                    for (unsigned int i = 0; i < 3; i++)
                    {
                        glVertex3f(
                            bsp->vertexes[(*it).vertex_offset + bsp->triangles[offset + n].vertex[i]].position[0],
                            bsp->vertexes[(*it).vertex_offset + bsp->triangles[offset + n].vertex[i]].position[1],
                            bsp->vertexes[(*it).vertex_offset + bsp->triangles[offset + n].vertex[i]].position[2]
                        );
                    }
                glEnd();
            }
        }

        if (show_single_texture_group)
        {
            break;
        }
    }
}

////////////////////////////////////////////////////////////////

void Draw::draw_vertexes()
{
    glBegin(GL_POINTS);
        std::vector<TextureGroup>::iterator it;
        for (it = bsp->texture_groups.begin(); it < bsp->texture_groups.end(); it++)
        {
            if (show_single_texture_group)
            {
                it += texture_group_i;
            }

            if (!((*it).triangle_length % 3) && !((*it).triangle_offset % 3))
            {
                glColor4f(
                    colour[((*it).texture + (N_COLOURS / 2)) % N_COLOURS][0],
                    colour[((*it).texture + (N_COLOURS / 2)) % N_COLOURS][1],
                    colour[((*it).texture + (N_COLOURS / 2)) % N_COLOURS][2],
                    1.0f
                );

                for (unsigned int n = 0; n < ((*it).triangle_length / 3); n++)
                {
                    unsigned int offset = ((*it).triangle_offset / 3);
                    for (unsigned int i = 0; i < 3; i++)
                    {
                        glVertex3f(
                            bsp->vertexes[(*it).vertex_offset + bsp->triangles[offset + n].vertex[i]].position[0],
                            bsp->vertexes[(*it).vertex_offset + bsp->triangles[offset + n].vertex[i]].position[1],
                            bsp->vertexes[(*it).vertex_offset + bsp->triangles[offset + n].vertex[i]].position[2]
                        );
                    }
                }
            }

            if (show_single_texture_group)
            {
                break;
            }
        }
    glEnd();
}

////////////////////////////////////////////////////////////////

void Draw::draw_text(std::string text, float x, float y, float alpha)
{
 
}

////////////////////////////////////////////////////////////////
