////////////////////////////////////////////////////////////////

void Draw::initialise()
{
    Window::initialise("CoD BSP Renderer - by Daevius & CoDEmanX", resolution.width, resolution.height, fullscreen, 32);

    //////////////////

    //corona::Image *image = corona::OpenImage("E:\\C\\CoD BSP Renderer\\bin\\Debug\\glass.png", corona::PF_R8G8B8A8, corona::FF_AUTODETECT);
    //glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, image->getWidth(), image->getHeight(), 0, GL_RGBA, GL_UNSIGNED_BYTE, image->getPixels());

    GLuint id;
    glGenTextures(1, &id);
    glBindTexture(GL_TEXTURE_2D, id);

    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);

    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, 2, 2, 0, GL_RGBA, GL_UNSIGNED_BYTE, text_background);
    textures["text_background"] = id;

    //////////////////

    glClearColor(0.0, 0.0, 0.0, 1.0);
    glClearDepth(1.0);

    //////////////////

    glDepthFunc(GL_LEQUAL);
    glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);

    glShadeModel(GL_SMOOTH);
    glEnable(GL_POINT_SMOOTH);
    glEnable(GL_LINE_SMOOTH);

    glPointSize(point_size);
    glLineWidth(line_width);

    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE);

    //////////////////

    glViewport(0, 0, resolution.width, resolution.height);

    //////////////////

    SDL_ShowCursor(0);
    SDL_WarpMouse(resolution.width / 2, resolution.height / 2);

    to_2d();

    glEnable(GL_TEXTURE_2D);
    glColor4f(1.0f, 1.0f, 1.0f, 1.0f);

    Window::pre_frame();
    loading();
    Window::post_frame();
}

////////////////////////////////////////////////////////////////

void Draw::loading()
{
}

////////////////////////////////////////////////////////////////

void Draw::set_bsp(BSP &ibsp)
{
    bsp = &ibsp;
}

////////////////////////////////////////////////////////////////

void Draw::reset()
{
    clip_near = 10.0;
    clip_far = 10000.0;

    point_size = 1.0;
    line_width = 1.0;
    alpha = 0.1;

    use_blending = 2;
    show_information = false;
    show_vertexes = true;
    show_triangles = true;
    show_lines = true;
    show_planes = false;
    show_single_texture_group = false;
    show_single_plane = false;
    texture_group_i = 0;
    plane_i = 0;

    glPointSize(point_size);
    glLineWidth(line_width);

    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE);
}

////////////////////////////////////////////////////////////////

void Draw::to_2d()
{
    glMatrixMode(GL_PROJECTION);

    glLoadIdentity();
    glOrtho(0, resolution.width, resolution.height, 0, -1.0, 1.0);

    glMatrixMode(GL_MODELVIEW);
}

void Draw::to_3d()
{
    glMatrixMode(GL_PROJECTION);

    glLoadIdentity();
    gluPerspective(45.0, (GLfloat) resolution.width / (GLfloat) resolution.height, clip_near, clip_far);

    glMatrixMode(GL_MODELVIEW);
}

////////////////////////////////////////////////////////////////
